"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * A Class decorator that takes in one or more classes and extends the prototype of a target class with the properties and methods from the provided classes.
 * @param classes One or more classes whose prototype will be extended onto the target class.
 */
function extendPrototype(...classes) {
    return function (target) {
        classes.forEach(mixin => {
            Object.getOwnPropertyNames(mixin.prototype).forEach(name => {
                var _a;
                Object.defineProperty(target.prototype, name, (_a = Object.getOwnPropertyDescriptor(mixin.prototype, name)) !== null && _a !== void 0 ? _a : Object.create(null));
            });
        });
    };
}
exports.default = extendPrototype;
//# sourceMappingURL=extend-prototype.js.map