import { Condition, Filter } from '@loopback/repository';
import { SoftDeleteEntity } from '../models';
/**
 * A builder for soft crud filter.
 * Example
 *
 * ```ts
 * const filterBuilder = new SoftFilterBuilder(originalFilter)
 *    .imposeCondition({ deleted: false })
 *    .build();
 * ```
 */
export declare class SoftFilterBuilder<E extends SoftDeleteEntity> {
    filter: Filter<E>;
    constructor(originalFilter?: Filter<E>);
    limit(limit: number): this;
    imposeCondition(conditionToEnsure: Condition<E>): this;
    build(): Filter<E>;
}
